;**********************************************************************
;    Filename:	au_ondo.asm 
;    Date:          	2005/11/27
;    File Version:
;**********************************************************************

	list      		p=16F684			 ; list directive to define processor
	#include		 <p16F684.inc>		 ; processor specific variable definitions

	__CONFIG    _CP_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT 

;***** VARIABLE DEFINITIONS
w_temp			EQU     0x20			 ; variable used for context saving 
status_temp		EQU     0x21			 ; variable used for context saving

wait_data		EQU	0x30		;wait data ram
taihi			EQU	0x31		;taihi data
out_data_1		EQU	0x32		;out data 1
out_data_10		EQU	0x33		;out data 10
out_data_f		EQU	0x34		;out data fugo
in_data			EQU	0x36		;in data
d_count			EQU	0x37		;hyouji count data
sagyou			EQU	0x38		;sagyou
wait_data_2		EQU	0x39		;wait data 2

tm0_setdata		EQU	0x63		;FFH-63H=156 156*128=19.968msec

;**********************************************************************
		ORG     		0x000             ; processor reset vector
  		goto    		main              ; go to beginning of program

;----------------------------------------------------------------------------------
		ORG     		0x004             ; interrupt vector location
		movwf   	w_temp            ; save off current W register contents
		movf		STATUS,w          ; move status register into W register
		movwf		status_temp       ; save off contents of STATUS register

		;---------------------------------	
		bcf			INTCON,T0IF
		movlw		tm0_setdata
		movwf		TMR0


next_int
		movf    		status_temp,w     ; retrieve copy of STATUS register
		movwf		STATUS            ; restore pre-isr STATUS register contents
		swapf   		w_temp,f
		swapf  		 w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt
;---------------------------------------------------------------------------------------
main
		call			osc_set
		call			port_set
		call			ad_set
		
		movlw		09h
		movwf		PORTA
		movlw		00h
		movwf		PORTC

		call			set_dcount
		
		call			timer0_set

		movlw		0ffh
		movwf		out_data_1
		movwf		out_data_10
		movwf		out_data_f
		movwf		in_data
;--------------------------------------
main_loop

		;--------------------------------- LED disp
		bcf			PORTA,1
		nop
		bcf			PORTA,2
		nop
		bcf			PORTA,5
		nop
		movf		out_data_1,0
		movwf		PORTC
		bsf			PORTA,4
		nop
		btfss		out_data_1,6
		bcf			PORTA,4
		nop
		bsf			PORTA,1
		nop
		call			wait_10
		
		bcf			PORTA,1
		nop
		bcf			PORTA,2
		nop
		bcf			PORTA,5
		nop
		movf		out_data_10,0
		movwf		PORTC
		bsf			PORTA,4
		nop
		btfss		out_data_10,6
		bcf			PORTA,4
		nop
		bsf			PORTA,2
		nop
		call			wait_10		
		
		bcf			PORTA,1
		nop
		bcf			PORTA,2
		nop
		bcf			PORTA,5
		nop
		movlw		0ffh
		movwf		PORTC
		bsf			PORTA,4
		nop
		btfss		out_data_f,0
		bcf			PORTA,4
		nop
		bsf			PORTA,5
		call			wait_10

		
		bcf			PORTA,1
		nop
		bcf			PORTA,2
		nop
		bcf			PORTA,5
		nop
		;---------------------------------
		decf		d_count,1
		btfss		STATUS,2
		goto		main_loop
		call			set_dcount
		;--------------------------------- CH0 AD start
		movlw		01h
		movwf		ADCON0
		call			wait_20
		call			wait_20
		bsf			ADCON0,1
ch0_wait
		btfsc		ADCON0,1
		goto		ch0_wait
		movf		ADRESH,0
		movwf		in_data

		;----------------------------------CH0 henkan
		movf		in_data,0
		movwf		sagyou
		movf		sagyou,0
		call			henkan1
		movwf		out_data_1
		movf		sagyou,0
		call			henkan2
		movwf		out_data_f
		
		movf		out_data_1,0
		movwf		sagyou
		swapf		sagyou,1
		movlw		0fh
		andwf		sagyou,0
		call			henkan7
		movwf		out_data_10
		movf		out_data_1,0
		movwf		sagyou
		movlw		0fh
		andwf		sagyou,0
		call			henkan7
		movwf		out_data_1
		
	
;---------------------------------------
		goto		main_loop
;-------------------------------------------------------------------------------
wait_20
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		return
;-------------------------------------------------------------------------------
wait_10
		movlw		5h
		movwf		wait_data_2
wait_10_2
		call			wait_1
		decfsz		wait_data_2,1
		goto		wait_10_2
		return

wait_0
		movlw		0ffh
		movwf		wait_data
		goto		wait_2
wait_1		
		movlw		0ffh
		movwf		wait_data
wait_2
		nop
		decfsz		wait_data,1
		goto		wait_2
		return
;------------------------------------------------------------------------------
set_dcount
		movlw		0x80
		movwf		d_count
		return
;------------------------------------------------------------------------------
henkan1
		movwf		taihi
		movlw		low(henkan1_table)
		addwf		taihi,1
		movlw		high(henkan1_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan1_table	;-----------
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		;---------------10		
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		079h
		retlw		078h
		retlw		077h
		retlw		076h
		;---------------20
		retlw		075h
		retlw		074h
		retlw		073h
		retlw		072h
		retlw		071h
		retlw		070h
		retlw		069h
		retlw		068h
		retlw		067h
		retlw		066h
		retlw		066h
		retlw		065h
		retlw		064h
		retlw		063h
		retlw		063h
		retlw		062h
		;---------------30
		retlw		061h
		retlw		060h
		retlw		060h
		retlw		059h
		retlw		058h
		retlw		058h
		retlw		057h
		retlw		056h
		retlw		056h
		retlw		055h
		retlw		055h
		retlw		054h
		retlw		053h
		retlw		053h
		retlw		052h
		retlw		052h
		;---------------40
		retlw		051h
		retlw		051h
		retlw		050h
		retlw		049h
		retlw		049h
		retlw		048h
		retlw		048h
		retlw		047h
		retlw		047h
		retlw		046h
		retlw		046h
		retlw		045h
		retlw		045h
		retlw		044h
		retlw		044h
		retlw		044h
		;---------------50
		retlw		043h
		retlw		043h
		retlw		042h
		retlw		042h
		retlw		041h
		retlw		041h
		retlw		040h
		retlw		040h
		retlw		040h
		retlw		039h
		retlw		039h
		retlw		038h
		retlw		038h
		retlw		038h
		retlw		037h
		retlw		037h
		;---------------60
		retlw		036h
		retlw		036h
		retlw		035h
		retlw		035h
		retlw		035h
		retlw		034h
		retlw		034h
		retlw		034h
		retlw		033h
		retlw		033h
		retlw		032h
		retlw		032h
		retlw		032h
		retlw		031h
		retlw		031h
		retlw		31h
		;---------------70
		retlw		30h
		retlw		30h
		retlw		29h
		retlw		29h
		retlw		29h
		retlw		28h
		retlw		28h
		retlw		28h
		retlw		27h
		retlw		27h
		retlw		27h
		retlw		26h
		retlw		26h
		retlw		26h
		retlw		25h
		retlw		25h
		;---------------80
		retlw		25h
		retlw		24h
		retlw		24h
		retlw		23h
		retlw		23h
		retlw		23h
		retlw		22h
		retlw		22h
		retlw		22h
		retlw		21h
		retlw		21h
		retlw		21h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		19h
		;--------------90
		retlw		19h
		retlw		19h
		retlw		18h
		retlw		18h
		retlw		18h
		retlw		17h
		retlw		17h
		retlw		17h
		retlw		16h
		retlw		16h
		retlw		16h
		retlw		15h
		retlw		15h
		retlw		15h
		retlw		14h
		retlw		14h
		;--------------A0
		retlw		14h
		retlw		13h
		retlw		13h
		retlw		13h
		retlw		12h
		retlw		12h
		retlw		12h
		retlw		11h
		retlw		11h
		retlw		10h
		retlw		10h
		retlw		10h
		retlw		09h
		retlw		09h
		retlw		09h
		retlw		08h
		;--------------B0
		retlw		08h
		retlw		08h
		retlw		07h
		retlw		07h
		retlw		07h
		retlw		06h
		retlw		06h
		retlw		05h
		retlw		05h
		retlw		05h
		retlw		04h
		retlw		04h
		retlw		04h
		retlw		03h
		retlw		03h
		retlw		02h
		;--------------C0
		retlw		02h
		retlw		02h
		retlw		01h
		retlw		01h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		01h
		retlw		01h
		retlw		02h
		retlw		02h
		retlw		03h
		retlw		03h
		retlw		03h
		retlw		04h
		retlw		04h
		;--------------D0
		retlw		05h
		retlw		05h
		retlw		06h
		retlw		06h
		retlw		07h
		retlw		07h
		retlw		08h
		retlw		08h
		retlw		09h
		retlw		09h
		retlw		10h
		retlw		10h
		retlw		11h
		retlw		11h
		retlw		12h
		retlw		13h
		;--------------E0
		retlw		13h
		retlw		14h
		retlw		14h
		retlw		15h
		retlw		16h
		retlw		16h
		retlw		17h
		retlw		18h
		retlw		19h
		retlw		19h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		;--------------F0
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h
		retlw		20h

;-------------------------------------------------------------------------------
henkan2
		movwf		taihi
		movlw		low(henkan2_table)
		addwf		taihi,1
		movlw		high(henkan2_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan2_table	;-----------
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------10		
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------20
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------30
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------40
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------50
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------60
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------70
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;---------------80
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------90
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------A0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------B0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		;--------------C0
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		0ffh
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------D0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------E0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		;--------------F0
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h
		retlw		00h


;------------------------------------------------------------------------------
henkan7
		movwf		taihi
		movlw		low(henkan7_table)
		addwf		taihi,1
		movlw		high(henkan7_table)
		movwf		PCLATH
		addcf		PCLATH,1
		movf		taihi,0
		movwf		PCL
henkan7_table	;-----------
		retlw		040h
		retlw		079h
		retlw		024h
		retlw		030h
		retlw		019h
		retlw		012h
		retlw		002h
		retlw		058h
		retlw		000h
		retlw		010h
		retlw		040h
		retlw		040h
		retlw		040h
		retlw		040h
		retlw		040h
		retlw		040h

;------------------------------------------------------------------------------
osc_set
		bsf			STATUS,RP0
								;(0)NC
								;(110)IRCF2-IRCF0
								;(0)OSTS
								;(1)IOFS
								;(00)SCS
		movlw		64h
		movwf		OSCCON
		bcf			STATUS,RP0
		return
;-------------------------------------------------------------------------------
port_set							;RA0,RA3(IN)
								;RA1,RA2,RA4,RA5(OUT)
								;RC0,RC1,RC2,RC3,RC4,RC5(OUT)
		bsf			STATUS,RP0
		clrf			TRISA
		bsf			TRISA,0
		nop
		bsf			TRISA,3
		nop
		clrf			TRISC
		bcf			STATUS,RP0
		return
;------------------------------------------------------------------------------
ad_set
								;(0)ADFM
								;(0)VCFG
								;(0)NC
								;(000)CHS2,CHS1,CHS0
								;(0)GO
								;(1)ADON
		movlw		01h
		movwf		ADCON0
		bsf			STATUS,RP0
								;(0)NC
								;(001)ADCS2,ADCS1,ADCS0
								;(0000)NC
		movlw		010h
		movwf		ADCON1
								;(0000001)ANS7-ANS0
		movlw		01h
		movwf		ANSEL
		bcf			STATUS,RP0
		return
;------------------------------------------------------------------------------
timer0_set

		bsf			STATUS,RP0
		movlw		086h		;(1)PORTB NOT PULLUP
								;(0)INTEDG
								;(0)TOCS
								;(0)TOSE
								;(0)PSA
								;(110)1/128
		movwf		OPTION_REG
		bcf			STATUS,RP0

		movlw		tm0_setdata
		movwf		TMR0
		bsf			INTCON,T0IE
		bcf			INTCON,GIE
		return
;-------------------------------------------------------------------------------

		end                     ; directive 'end of program'
